# ManyBodyDynLearning

This repository is a code package accompanying paper "Scalable Hamiltonian learning for large-scale out-of-equilibrium quantum dynamics", arXiv:2103.01240.

The folder 'NN' contains the code for a neural-network based estimation of many-body Hamiltonians from measurement snapshots. We provide code to generate the snapshots, pretrained networks for Bose-Hubbard model, and script for full parameter estimation from input data. In particular, the folder 'network' contains the neural network and the saved checkpoints for the estimation of the Bose-Hubbard parameters for 2500 and 20000 snapshots. Code and a script to execute an exemplary single run of the parameter estimation process can be found in the folder 'single_run'. In the folder 'averaged_run', averaged parameter estimation over a larger number of data sets can be performed and plotted together with comparison with the Bayesian inference, reproducing Figure 4 of the above reference. For detailed usage instructions and explanation of the file structure, please see the readme inside the respective folders.

The folder 'Bayes' contains the code for the Bayesian estimation benchmark.  The folder 'Bayes_minimal' contains a minimal example of Bayes' estimation of only two parameters of the Bose-Hubbard Hamiltonian and can be run on the PC/laptop. The folder 'Bayes_HPC' contains the full Bayes estimation of the model as shown in the manuscript - this simulation is parallelized for a HPC cluster. For detailed usage instructions and explanation of the file structure, please see the readme inside the respective folders.

